---
title: text-rendering
slug: Web/SVG/Attribute/text-rendering
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <code><strong>text-rendering</strong></code> attribute provides hints to the renderer about what tradeoffs to make when rendering text.</p>

<p class="note"><strong>Note:</strong> As a presentation attribute, <code>text-rendering</code> can be used as a CSS property. See the {{cssxref("text-rendering", "CSS text-rendering")}} property for more information.</p>

<p>As a presentation attribute, it can be applied to any element but it has effect only on the following element: {{SVGElement("text")}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css notranslate">html, body, svg {
  height: 100%;
}</pre>
</div>

<pre class="brush: html; highlight[2,3] notranslate">&lt;svg viewBox="0 0 140 40" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;text y="15" text-rendering="geometricPrecision"&gt;Geometric precision&lt;/text&gt;
  &lt;text y="35" text-rendering="optimizeLegibility"&gt;Optimized legibility&lt;/text&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample("topExample", "420", "140")}}</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>auto</code> | <code>optimizeSpeed</code> | <code>optimizeLegibility</code> | <code>geometricPrecision</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>auto</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>discrete</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>auto</code></dt>
 <dd>This value indicates that the user agent shall make appropriate tradeoffs to balance speed, legibility and geometric precision, but with legibility given more importance than speed and geometric precision.</dd>
 <dt><code>optimizeSpeed</code></dt>
 <dd>This value indicates that the user agent shall emphasize rendering speed over legibility and geometric precision. This option will sometimes cause some user agents to turn off text anti-aliasing.</dd>
 <dt><code>optimizeLegibility</code></dt>
 <dd>This value indicates that the user agent shall emphasize legibility over rendering speed and geometric precision. The user agent will often choose whether to apply anti-aliasing techniques, built-in font hinting or both to produce the most legible text.</dd>
 <dt><code>geometricPrecision</code></dt>
 <dd>This value indicates that the user agent shall emphasize geometric precision over legibility and rendering speed. This option will usually cause the user agent to suspend the use of hinting so that {{Glossary("glyph")}} outlines are drawn with comparable geometric precision to the rendering of path data.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "painting.html#TextRenderingProperty", "text-rendering")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "painting.html#TextRenderingProperty", "text-rendering")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.presentation.text-rendering")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("text-rendering", "CSS text-rendering")}}</li>
</ul>
